﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GS.Report.Telerik.AggregateFunction
{
    // Jul.01.09
    public partial class Sum
    {
        Decimal c_decResult = 0;
        String c_strFieldName = String.Empty;


        #region New, Load, Initial

        public Sum()
        {
        }

        public Sum(String FieldName)
        {
            c_strFieldName = FieldName;
        }

        public void Initial()
        {
            this.Initial(0);
        }

        public void Initial(Decimal InitialValue)
        {
            c_decResult = 0;
        }

        #endregion


        #region Properties

        public String FieldName
        {
            get { return c_strFieldName; }
            set { c_strFieldName = value; }
        }

        public Decimal Result
        {
            get { return c_decResult; }
        }

        #endregion


        #region Properties

        public Boolean Accumulate(object value)
        {
            if (null == value) { return false; }
            
            Boolean blnResult = false;

            Decimal decValue = 0;
            if (Decimal.TryParse(value.ToString(), out decValue))
            {
                blnResult = true;
                this.Accumulate(decValue);
            }

            return blnResult;
        }

        public void Accumulate(Decimal value)
        {
            c_decResult += value;
        }

        #endregion
    
    }       // Sum
}
